#include "mp_simulation.h"

void addmax(map<int,double> &p, int k, double x){
  map<int,double>::iterator itr;
  itr = p.find(k);
  if (itr == p.end()) p.insert(map<int,double>::value_type(k,x));
  else if (itr->second < x) itr->second = x;
}

// read the input once and get the nodes and characters
void read_pre(ifstream &ifs, Aton<string> &nodes, Aton<string> &ac){
  char x[MAX_LEN], y[MAX_LEN], a[MAX_LEN];
  string s;

  while(1){
    getline(ifs,s);
    if (s == "-1" || s == "") break;
    sscanf(s.c_str(), "%s %*lf", a);
    nodes.insert(a);
  }

  while(1){
    getline(ifs,s);
    if (s == "-1" || s == "") break;
    sscanf(s.c_str(), "%s %s %s %*lf", x, y, a);
    nodes.insert(x);
    nodes.insert(y);
    ac.insert(a);
  }

  while(1){
    getline(ifs,s);
    if (s == "-1" || s == "") break;
    sscanf(s.c_str(), "%s %*lf", a);
    nodes.insert(a);
  }

  ifs.clear();
  ifs.seekg(0,ios_base::beg);
}

// read the body
void read_body(ifstream &ifs, map<int,double> **c, map<int,double> &ci, map<int,double> &cv, Aton<string> &nodes, Aton<string> &ac, bool trans){
  string s;
  char x[MAX_LEN];
  char y[MAX_LEN];
  char a[MAX_LEN];
  double p;

  while(1){
    getline(ifs,s);
    if (s.empty()) break;
    sscanf(s.c_str(), "%s %lf", x, &p);
    addmax(ci,nodes[x],p);
  }

  while(1){
    getline(ifs,s);
    if (s.empty()) break;
    sscanf(s.c_str(), "%s %s %s %lf", x, y, a, &p);
    if (trans) addmax(c[ac[a]][nodes[y]],nodes[x],p);
    else addmax(c[ac[a]][nodes[x]],nodes[y],p);
  }

  while(1){
    getline(ifs,s);
    if (s.empty()) break;
    sscanf(s.c_str(), "%s %lf", x, &p);
    addmax(cv,nodes[x],p);
  }
}
