#include <map>
#include <set>
#include <vector>
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <string.h>
#include <limits>
#include <limits.h>
#include <stdlib.h>

#define MAX_LEN 256

#define BWD 1
#define DEBUGPTM 2
#define OUTPUT 4
#define OUTPUTFILE 8

#define SIMULATION_FOUND 0
#define SIMULATION_NOTFOUND 1
#define ITERATION_LIMIT 2



using namespace std;

template <typename T> class Aton{
 private:
  int i;
  map<T,int> p;
 public:
  Aton();
  bool insert(T);
  int operator[](T);
  int size();
};
template <typename T> Aton<T>::Aton(){
  i = 0;
}
template <typename T> bool Aton<T>::insert(T s){
  bool b = p.insert(make_pair(s,i)).second;
  if (b) i++;
  return(b);
}
template <typename T> int Aton<T>::operator[](T s){
  return(p[s]);
}
template <typename T> int Aton<T>::size(){
  return(i);
}


void read_pre(ifstream &ifs, Aton<string> &nodes, Aton<string> &ac);
void read_body(ifstream &, map<int,double> **, map<int,double> &, map<int,double> &, Aton<string> &, Aton<string> &, bool);

void output_input(const string &cn, map<int,double>** c, const string &cin, map<int,double> ci, const string &cvn, map<int,double> cv, int a, int n, bool trans);

int solve(int a, int n, int m, map<int,double> **c, map<int,double> &ci, map<int,double> &cv, map<int,double> **d, map<int,double> &di, map<int,double> &dv, double *x, int flag, int iter);
